Index: drivers/dahdi/dahdi_echocan_kb1.c
===================================================================
--- drivers/dahdi/dahdi_echocan_kb1.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_kb1.c	(working copy)
@@ -266,7 +281,7 @@
 
 static inline void init_cc(struct ec_pvt *pvt, int N, int maxy, int maxu)
 {
-	void *ptr = pvt;
+	char *ptr = (char *) pvt;
 	unsigned long tmp;
 
 	/* Double-word align past end of state */
@@ -281,9 +296,9 @@
 	pvt->beta2_i = DEFAULT_BETA1_I;
   
 	/* Allocate coefficient memory */
-	pvt->a_i = ptr;
+	pvt->a_i = (int *) ptr;
 	ptr += (sizeof(int) * pvt->N_d);
-	pvt->a_s = ptr;
+	pvt->a_s = (short *) ptr;
 	ptr += (sizeof(short) * pvt->N_d);
 
 	/* Reset Y circular buffer (short version) */
Index: drivers/dahdi/dahdi_echocan_mg2.c
===================================================================
--- drivers/dahdi/dahdi_echocan_mg2.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_mg2.c	(working copy)
@@ -307,7 +322,7 @@
 
 static inline void init_cc(struct ec_pvt *pvt, int N, int maxy, int maxu)
 {
-	void *ptr = pvt;
+	char *ptr = (char *) pvt;
 	unsigned long tmp;
 
 	/* Double-word align past end of state */
@@ -322,15 +337,15 @@
 	pvt->beta2_i = DEFAULT_BETA1_I;
   
 	/* Allocate coefficient memory */
-	pvt->a_i = ptr;
+	pvt->a_i = (int *) ptr;
 	ptr += (sizeof(int) * pvt->N_d);
-	pvt->a_s = ptr;
+	pvt->a_s = (short *) ptr;
 	ptr += (sizeof(short) * pvt->N_d);
 
 	/* Allocate backup memory */
-	pvt->b_i = ptr;
+	pvt->b_i = (int *) ptr;
 	ptr += (sizeof(int) * pvt->N_d);
-	pvt->c_i = ptr;
+	pvt->c_i = (int *) ptr;
 	ptr += (sizeof(int) * pvt->N_d);
 
 	/* Reset Y circular buffer (short version) */
@@ -387,7 +402,7 @@
 }
 
 #ifdef DC_NORMALIZE
-short inline dc_removal(int *dc_estimate, short samp)
+static short inline dc_removal(int *dc_estimate, short samp)
 {
 	*dc_estimate += ((((int)samp << 15) - *dc_estimate) >> 9);
 	return samp - (*dc_estimate >> 15);
